unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

Type
 TBIOS=record
 case boolean of
  True:(IBM:record
             Copyright:array[0..80] of char;
             Dummy1:array[81..$FF70] of char;
             Ver:array[1..22] of char;         // $FF71..$FF86 = 'IBM BIOS Ver NZKT36.0 '#0
             Dummy2:array[$FF87..$FF9F] of char;
             check:array[1..13] of char;       // 'UVPD0RESERVE'
             EPROM:array[1..9] of char;        // 'NZKT36AFR'
             SerialNumber:array[1..7] of char; // '5503X49'
             BoardSN:array[1..11] of char;     // '80K3GX7419L'
             PCType:array[1..4] of char;       // '6561'
             Modele:array[1..3] of char;       // '320'
             Dummy3:array[$FFCF..$FFF4] of char;
             Date:array[1..8] of char;
             Dummy4:array[$FFFD..$FFFF] of char
            end);
 False:(RAW:array[0..$FFFF] of byte);
 end;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    Edit4: TEdit;
    Label5: TLabel;
    Edit5: TEdit;
    Memo1: TRichEdit;
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
    BIOS:TBIOS;
    procedure DumpBIOS;
    procedure WMUser(Var Msg:TMessage); message wm_user;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
function WOWGetVDMPointer(vp,dwBytes:DWORD; fProtectedMode:BOOL):pointer;   far; stdcall; external 'WOW32.DLL';
function WOWGetVDMPointerFix(vp,dwBytes:DWORD; fProtectedMode:BOOL):pointer; far; stdcall; external 'WOW32.DLL';
procedure WOWGetVDMPointerUnfix(vp:pointer); far; stdcall; external 'WOW32.DLL';

procedure TForm1.DumpBIOS;
 var
  x:word;
  s:string;
  d:string;
  c:char;
 begin
  s:='0000';
  d:=' ';
  Memo1.Cursor:=crHourglass;
  for x:=0 to $FFFF do begin
   Application.ProcessMessages;
   c:=Chr(BIOS.Raw[x]);
   s:=s+' '+IntToHex(Ord(c),2);
   case c of
    #00:c:='.';
    #09:c:='-';
    #10:c:='n';
    #13:c:='/';
   end;
   d:=d+c;
   if length(s)=4+3*16 then begin
    Memo1.Lines.Add(s+d);
    s:=IntToHex(x+1,4);
    d:=' ';
   end;
  end;
  Memo1.Cursor:=crDefault;
 end;

procedure TForm1.FormCreate(Sender: TObject);
 begin
  PostMessage(Handle,wm_user,0,0);
 end; 

procedure TForm1.WMUser(Var Msg:TMessage);
 var
  pBIOS:^TBIOS;
 begin
  pBIOS:=WOWGetVDMPointerFix($F0000000,$FFFF,BOOL(0));
  move(pBIOS^,BIOS,SizeOf(BIOS));
  WOWGetVDMPointerUnfix(pBIOS);
  if BIOS.IBM.Check=#170'UVPD0RESERVE' then begin
   Edit1.Text:=BIOS.IBM.CopyRight;
   Edit2.Text:=BIOS.IBM.EPROM;
   Edit3.Text:=BIOS.IBM.Date;
   Edit4.Text:=BIOS.IBM.PCType+'-'+BIOS.IBM.Modele;
   Edit5.Text:=BIOS.IBM.SerialNumber;
  end;
  DumpBIOS;
 end;

end.
